--Bitmap2VRayHDRI converter
--Based on Chaosgroup V-Ray Script
--Changes:
-- Added tx convertion.
-- Added progress bar.
-- Path config inside maxscript.

-- config 
img2tiledexr_path = "G:\GFX\TOOLS\img2tiledexr.exe"
maketx_path = "G:\GFX\TOOLS\maketx.exe"
defaulttx_parameters = " -v -u --oiio --checknan --filter lanczos3"
-- config here

convertB2Tiled_ConvertEXR=false
convertB2Tiled_ConverterPath=img2tiledexr_path
convertB2Tiled_ConvertHalf=false
convertB2Tiled_ConvertCompression="zip"
convertB2Tiled_ConvertTilesize=64
convertB2Tiled_ConvertLinear="auto"
convertB2Tiled_ConverterErrors=0
convertB2Tiled_Bitmaps_Counter=0
convertB2Tiled_Bitmaps_Counter_current=0
convertB2Tiled_TxParameters=""
convertB2Tiled_ConvertTX=false
vrayBitmap2VRayHDRI
convertB2Tiled_TEXRConverterRollout
debugger = ""


--Count Bitmaptextures
/*
fn convertB2Tiled_Bitmaps_Count_SubMtl material = (
	if (material!=undefined) do (
		for i=1 to (getNumSubMtls material) do (
			convertB2Tiled_Bitmaps_Count_SubMtl (getSubMtl material i)
		)
		
		for i=1 to (getNumSubTexmaps material) do (
			convertB2Tiled_Bitmaps_Count_SubTex (getSubTexmap material i)
		)
	)
)

fn convertB2Tiled_Bitmaps_Count_SubTex texmap = (
	if (texmap!=undefined) then (
		if ((classof texmap)==Bitmaptexture) then (
			convertB2Tiled_Bitmaps_Counter = convertB2Tiled_Bitmaps_Counter + 1
			undefined
		)
		else (
			for i = 1 to (getNumSubTexmaps texmap) do (
				local tex=(convertB2Tiled_Bitmaps_Count_SubTex (getSubTexmap texmap i))
				if (tex!=undefined) do (
					setSubTexmap texmap i tex
				)
			)
			undefined
		)
	)
	else (
		undefined
	)
)

fn convertB2Tiled_Bitmaps_Count node = (
	if isValidNode node then (
		convertB2Tiled_Bitmaps_Count_SubMtl node.material
	)
	for i=1 to node.children.count do (
		convertB2Tiled_Bitmaps_Count node.children[i]
	)
)

convertB2Tiled_Bitmaps_Count rootNode
*/
rollout convertB2Tiled_Rollout "V-Ray Bitmap to VRayHDRI texmap converter" width: 460 height: 137 (
	label label_message "All scene materials' Bitmap texmaps will be converted to VRayHDRI texmap." width:400 height:13 align:#center offset:[0, 10]
	
	checkbox check_convertEXR "Convert bitmaps to tiled *.exr or *.tx." checked:false width:400 align:#center offset:[0, 10]
	
	button btn_start "Convert" width:60 align:#right across:2 offset:[150, 0]
	button btn_cancel "Cancel" width:60 align:#right
	
	--progress bar
	progressbar pb_convertB2Tiled color:red offset:[0, 10]
	
	local cancelled=false
	local convertPath=undefined
	local convertHalf=false
	local convertCompression="zip"
	local convertTilesize=64
	local convertLinear="auto"
	local converttxparms = ""
	local converttotxonly = false
	
	on btn_start pressed do (
		convertB2Tiled_ConverterErrors=0
		cancelled=false
			
		if (check_convertEXR.checked) do (
			CreateDialog convertB2Tiled_TEXRConverterRollout modal:true
		)
		if (NOT cancelled) do (
			vrayBitmap2VRayHDRI exrConvert:check_convertEXR.checked maketx:converttotxonly maketxparm:converttxparms exrPath:convertPath exrHalf:convertHalf exrCompress:convertCompression exrTilesize:convertTilesize exrLinear:convertLinear
			if (convertB2Tiled_ConverterErrors>0) do (
				messageBox ("There were "+(convertB2Tiled_ConverterErrors as String)+" images that did not convert successfully to tiled EXR format. The original images were left in place.") title:"Tiled EXR conversion error"
			)
		)
		
		destroyDialog convertB2Tiled_Rollout
	)
	
	on btn_cancel pressed do (
		destroyDialog convertB2Tiled_Rollout
	)
)

rollout convertB2Tiled_TEXRConverterRollout "Img2tiledexr tool conversion options" width: 460 height: 350 (
	label label_message "Tiled EXR options." width:400 height:13 align:#center offset:[0, 10]
	
	edittext edit_path width:394 across:2 align:#left offset:[13, 0]
	button btn_path "..." width:20 height:18 align:#right offset:[0, 0]
	
	checkbox check_half "Half - store data as 16-bit floating point numbers." checked:false width:400 align:#center offset:[0, 10]
	
	label label_compression "Compression method:" width:200 height:13 across:2 align:#center offset:[10, 2]
	dropdownlist drop_compression items:#("None", "RLE", "Zips", "Zip", "PIZ", "PXR24") selection:4 width:100 align:#center offset:[-150, 0]
	
	label label_tilesize "Tile size:" width:200 height:13 across:2 align:#center offset:[10, 2]
	dropdownlist drop_tilesize items:#("32x32", "64x64", "128x128") selection:2 width:100 align:#center offset:[-150, 0]
	
	label label_linearmode "Linear mode:" width:200 height:13 across:2 align:#center offset:[10, 2]
	dropdownlist drop_linearmode items:#("Off", "On", "Auto") selection:3 width:100 align:#center offset:[-150, 0]
	
	label label_message2 "Tiled TX options." width:400 height:13 align:#center offset:[0, 10]

	edittext edit_tx_path width:394 across:2 align:#left offset:[13, 0]
	button btn_tx_path "..." width:20 height:18 align:#right offset:[0, 0]	
	edittext edit_tx_parameters width:394 height:18 align:#left offset:[13, 10]

	checkbox check_use_tx_only "Convert to *.tx " checked:false width:400 align:#center offset:[0, 10]	
	
	button btn_set "OK" width:60 align:#right across:2 offset:[150, 10]
	button btn_cancel "Cancel" width:60 align:#right offset:[0, 10]
	
	
	
	on convertB2Tiled_TEXRConverterRollout open do (
		if (convertB2Tiled_Rollout.check_convertEXR.checked) do (
			--local ver=getMaxReleaseAsString()
			--local tmpPath=getVRayInstallPath ver
			local tmpPath=img2tiledexr_path
			if (tmpPath!=undefined) do (
				--append tmpPath "\\tools\\img2tiledexr.exe"
				edit_path.text=tmpPath
				edit_path.enabled=true
				btn_path.enabled=true
			)
			edit_tx_path.text=maketx_path
			edit_tx_parameters.text=defaulttx_parameters
			check_use_tx_only.state=false
			edit_tx_path.enabled=false
			btn_tx_path.enabled=false
			edit_tx_parameters.enabled=false
		)
	)
	
	on btn_tx_path pressed do (
		local toolPath=getOpenFileName filename:edit_path.text \
								types:"Executable File (maketx.exe)|maketx.exe"
		if (toolPath!=undefined) do (
			edit_path.text=toolPath
		)
	)
	
	on btn_path pressed do (
		local toolPath=getOpenFileName filename:edit_path.text \
								types:"Executable File (img2tiledexr.exe)|img2tiledexr.exe"
		if (toolPath!=undefined) do (
			edit_path.text=toolPath
		)
	)
	
	on check_use_tx_only changed state do (
		if state == on then (
			edit_path.enabled=false
			btn_path.enabled=false
			drop_compression.enabled=false
			drop_tilesize.enabled=false
			drop_linearmode.enabled=false
			check_half.enabled=false
			convertB2Tiled_Rollout.converttotxonly = true
			edit_tx_path.enabled=true
			btn_tx_path.enabled=true
			edit_tx_parameters.enabled=true
		) else (
					edit_path.enabled=true
					btn_path.enabled=true
					drop_compression.enabled=true
					drop_tilesize.enabled=true
					drop_linearmode.enabled=true
					check_half.enabled=true
					convertB2Tiled_Rollout.converttotxonly = false
					edit_tx_path.enabled=false
					btn_tx_path.enabled=false
					edit_tx_parameters.enabled=false
		) 
	)	
	
	on btn_set pressed do (
		convertB2Tiled_Rollout.converttxparms = edit_tx_parameters.text
		if check_use_tx_only.state == on then (convertB2Tiled_Rollout.convertPath=edit_tx_path.text) else (	convertB2Tiled_Rollout.convertPath=edit_path.text )
		convertB2Tiled_Rollout.convertHalf=check_half.checked
		convertB2Tiled_Rollout.convertCompression=case drop_compression.selection of (
			1:	"none"
			2:	"rle"
			3:	"zips"
			4:	"zip"
			5:	"piz"
			6:	"pxr24"
		)
		convertB2Tiled_Rollout.convertTilesize=case drop_tilesize.selection of (
			1:	32
			2:	64
			3:	128
		)
		convertB2Tiled_Rollout.convertLinear=case drop_linearmode.selection of (
			1:	"off"
			2:	"on"
			3:	"auto"
		)
		destroyDialog convertB2Tiled_TEXRConverterRollout
	)
	
	on btn_cancel pressed do (
		convertB2Tiled_Rollout.cancelled=true
		destroyDialog convertB2Tiled_TEXRConverterRollout
	)
)
convertB2Tiled_TEXRConverterRollout=convertB2Tiled_TEXRConverterRollout


fn convertB2Tiled_img2tiledexr imgpath=(
	if ((classof imgpath)==String) then (
		if ((stricmp (getFilenameType imgpath) ".exr")!=0) then (
			outpath=(getFilenamePath imgpath)+(getFilenameFile imgpath)+".exr"
		)
		else (
			outpath=imgpath
		)
		
		if ((classof convertB2Tiled_ConverterPath)==String) do (
			local cmdConverter=("\""+convertB2Tiled_ConverterPath+"\" \""+imgpath+"\" \""+outpath+"\"")
			if (convertB2Tiled_ConvertHalf) then (append cmdConverter " -half")
			else (append cmdConverter " -32bit")
			append cmdConverter (" -compression "+convertB2Tiled_ConvertCompression)
			append cmdConverter (" -tileSize "+(convertB2Tiled_ConvertTilesize as String))
			append cmdConverter (" -linear "+convertB2Tiled_ConvertLinear)
			vrayShellLaunch cmdConverter waitExec:true hideConsole:false
		)
		
		if (doesFileExist outpath) then (
			outpath
		)
		else (
			if (convertB2Tiled_ConverterErrors!=undefined) do (
				convertB2Tiled_ConverterErrors=convertB2Tiled_ConverterErrors+1
			)
			imgpath
		)
	)
	else (
		undefined
	)
)


fn convertB2Tiled_maketx imgpath=(
	if ((classof imgpath)==String) then (
		if ((stricmp (getFilenameType imgpath) ".tx")!=0) then (
			outpath=(getFilenamePath imgpath)+(getFilenameFile imgpath)+".tx"
		)
		else (
			outpath=imgpath
		)
		
		if ((classof convertB2Tiled_ConverterPath)==String) do (
			local cmdConverter=(convertB2Tiled_ConverterPath+" "+convertB2Tiled_TxParameters+" "+imgpath+" -o "+outpath)
			--if (convertB2Tiled_ConvertHalf) then (append cmdConverter " -half")
			--else (append cmdConverter " -32bit")
			--append cmdConverter (" -compression "+convertB2Tiled_ConvertCompression)
			--append cmdConverter (" -tileSize "+(convertB2Tiled_ConvertTilesize as String))
			--append cmdConverter (" -linear "+convertB2Tiled_ConvertLinear)
			vrayShellLaunch cmdConverter waitExec:true hideConsole:false -- changed: console unhidden
		)
		append debugger outpath
		
		if (doesFileExist outpath) then (
			outpath
		)
		else (
			if (convertB2Tiled_ConverterErrors!=undefined) do (
				convertB2Tiled_ConverterErrors=convertB2Tiled_ConverterErrors+1
			)
			imgpath
		)
	)
	else (
		undefined
	)
)


fn convertB2Tiled_Texmap texmap=(
	if (texmap!=undefined and texmap.fileName!=undefined) then (
		local tex=VRayHDRI()
		tex.name=texmap.name+"_VRay"
		if (convertB2Tiled_ConvertEXR) then (
					if(convertB2Tiled_ConvertTX) then (
								tex.HDRIMapName=convertB2Tiled_maketx texmap.fileName	
							) else (
								tex.HDRIMapName=convertB2Tiled_img2tiledexr texmap.fileName
							)
			
			if (tex.HDRIMapName!=undefined) do (
				local isHDRI=(((stricmp (getFilenameType texmap.fileName) ".exr")==0) OR ((stricmp (getFilenameType texmap.fileName) ".hdr")==0))
				if (NOT isHDRI) do (
					local gamma=vrayGetBitmapGamma texmap
					if (gamma!=undefined) then (
						if (convertB2Tiled_ConvertLinear!="off") AND (convertB2Tiled_ConvertTX==false) then (
							gamma=gamma/2.2
						)
						tex.gamma=1.0/gamma
					)
				) 
			)
		)
		else (
			tex.HDRIMapName=texmap.fileName
			
			local isHDRI=(((stricmp (getFilenameType texmap.fileName) ".exr")==0) OR ((stricmp (getFilenameType texmap.fileName) ".hdr")==0))
			if (NOT isHDRI) do (
				local gamma=vrayGetBitmapGamma texmap
				if (gamma!=undefined) then (
					tex.gamma=1.0/gamma
				)
			)
		)
		tex.mapType=4
		tex.UVGen.blur=texmap.coords.blur
		tex.UVGen.mapping=texmap.coords.mapping
		tex.UVGen.mapChannel=texmap.coords.mapChannel
		tex.UVGen.mappingType=texmap.coords.mappingType
		tex.UVGen.UVW_Type=texmap.coords.UVW_Type
		tex.UVGen.U_Mirror=texmap.coords.U_Mirror
		tex.UVGen.V_Mirror=texmap.coords.V_Mirror
		tex.UVGen.U_Tile=texmap.coords.U_Tile
		tex.UVGen.V_Tile=texmap.coords.V_Tile
		tex.UVGen.showMapOnBack=texmap.coords.showMapOnBack
		tex.UVGen.Noise_On=texmap.coords.Noise_On
		tex.UVGen.Noise_Animate=texmap.coords.Noise_Animate
		tex.UVGen.realWorldScale=texmap.coords.realWorldScale
		tex.UVGen.realWorldHeight=texmap.coords.realWorldHeight
		tex.UVGen.realWorldWidth=texmap.coords.realWorldWidth
		tex.UVGen.phase=texmap.coords.phase
		tex.UVGen.U_Angle=texmap.coords.U_Angle
		tex.UVGen.V_Angle=texmap.coords.V_Angle
		tex.UVGen.W_Angle=texmap.coords.W_Angle
		tex.UVGen.Noise_Amount=texmap.coords.Noise_Amount
		tex.UVGen.Noise_Size=texmap.coords.Noise_Size
		tex.UVGen.Noise_Levels=texmap.coords.Noise_Levels
		tex.UVGen.Blur_Offset=texmap.coords.Blur_Offset
		tex.UVGen.u_tiling=texmap.coords.u_tiling
		tex.UVGen.v_tiling=texmap.coords.v_tiling
		tex.UVGen.u_offset=texmap.coords.u_offset
		tex.UVGen.v_offset=texmap.coords.v_offset

		--added ouput conversion
		tex.output.invert=texmap.output.invert
		--tex.output.clamp = texmap.output.clamp
		tex.output.clamp = true
		tex.output.alphaFromRGB = texmap.output.alphaFromRGB
		tex.output.rgb_level = texmap.output.rgb_level
		tex.output.rgb_offset = texmap.output.rgb_offset
		tex.output.output_amount = texmap.output.output_amount
		tex.output.bump_amount = texmap.output.bump_amount
		-- it's not possible to access mono/rgb output curve from maxscript... so just don't use it for now.		
		
		tex
	)
	else (
		undefined
	)
)

-- Updating Progress Bar

fn convertB2Tiled_UpdateCounter = (
	convertB2Tiled_Bitmaps_Counter_current = convertB2Tiled_Bitmaps_Counter_current + 1
	convertB2Tiled_Rollout.pb_convertB2Tiled.value = 100*convertB2Tiled_Bitmaps_Counter_current/convertB2Tiled_Bitmaps_Counter
)


fn convertB2Tiled_SubTex texmap = (
	if (texmap!=undefined) then (
		if ((classof texmap)==Bitmaptexture) then (
			--convertB2Tiled_UpdateCounter()
			local tex=convertB2Tiled_Texmap texmap
			tex
		)
		else (
			for i = 1 to (getNumSubTexmaps texmap) do (
				local tex=(convertB2Tiled_SubTex (getSubTexmap texmap i))
				if (tex!=undefined) do (
					setSubTexmap texmap i tex
				)
			)
			undefined
		)
	)
	else (
		undefined
	)
)

fn convertB2Tiled_SubMtl material = (
	if (material!=undefined) do (
		for i=1 to (getNumSubMtls material) do (
			convertB2Tiled_SubMtl (getSubMtl material i)
		)
		
		for i=1 to (getNumSubTexmaps material) do (
			local tex=(convertB2Tiled_SubTex (getSubTexmap material i))
			if (tex!=undefined) do (setSubTexmap material i tex)
		)
	)
)

fn convertB2Tiled_NodeMtl node =(
	if isValidNode node then (
		convertB2Tiled_SubMtl node.material
	)
	for i=1 to node.children.count do (
		convertB2Tiled_NodeMtl node.children[i]
	)
)

fn VrayBitmap2VRayHDRI exrConvert: maketx: maketxparm: exrPath: exrHalf: exrCompress: exrTilesize: exrLinear: =(
	convertB2Tiled_ConvertEXR=false
	if (exrConvert!=unsupplied) do (
		if ((classof exrConvert)!=BooleanClass) do (print "Expected Boolean for exrConvert:")
		if (exrConvert) do (
			if (exrPath!=unsupplied) then (
				if ((classof exrPath)!=String) do (print "Expected String for exrPath:")
				convertB2Tiled_ConverterPath=exrPath
			)
			else (
				if (convertB2Tiled_ConverterPath==undefined) do (
					local ver=getMaxReleaseAsString()
					--convertB2Tiled_ConverterPath=getVRayInstallPath ver
					--if (convertB2Tiled_ConverterPath!=undefined) do (append convertB2Tiled_ConverterPath "\\tools\\img2tiledexr.exe")
				)
			)
		)
		convertB2Tiled_ConvertEXR=exrConvert
	)
	
	if (exrHalf!=unsupplied) do (
		if ((classof exrHalf)!=BooleanClass) do (print "Expected Boolean for exrHalf:")
		convertB2Tiled_ConvertHalf=exrHalf
	)
	if (exrCompress!=unsupplied) do (
		if ((classof exrCompress)!=String) do (print "Expected String for exrCompress:")
		convertB2Tiled_ConvertCompression=exrCompress
	)
	if (exrTilesize!=unsupplied) do (
		if ((classof exrTilesize)!=Integer) do (print "Expected Integer for exrTilesize:")
		convertB2Tiled_ConvertTilesize=exrTilesize
	)
	if (exrLinear!=unsupplied) do (
		if ((classof exrLinear)!=String) do (print "Expected String for exrLinear:")
		convertB2Tiled_ConvertLinear=exrLinear
	)
	if (maketx!=unsupplied) do (
		if ((classof maketx)!=BooleanClass) do (print "Expected Boolean for maketx:")
		convertB2Tiled_ConvertTX=maketx
	)
	if (maketxparm!=unsupplied) do (
		if ((classof maketxparm)!=String) do (print "Expected String for maketxparm:")
		convertB2Tiled_TxParameters=maketxparm
	)
	
	convertB2Tiled_NodeMtl rootNode
	
	for i=1 to meditMaterials.count do (
		local m=meditMaterials[i]
		if (m.superClassID==3072) then ( -- This is a material
			convertB2Tiled_SubMtl m
		) else ( -- This is a texture
			m=convertB2Tiled_SubTex m
			if (m!=undefined) then meditMaterials[i]=m
		)
		updateMTLInMedit meditMaterials[i]
	)
)

vrayBitmap2VRayHDRI=VrayBitmap2VRayHDRI
CreateDialog convertB2Tiled_Rollout modal:true